# coding: utf-8

"""
    Jira

    The curated-issue-assignee resources from the uipath-atlassian-jira element

    The version of the OpenAPI document: 1.6.9
    Contact: eduard.stanculet@cloud-elements.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr
from typing_extensions import Annotated
from u_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_atlassian_jira.curated_issue_assignee.models.replace_curated_issue_assignee_by_issue_id_or_key_request import ReplaceCuratedIssueAssigneeByIssueIdOrKeyRequest

from u_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_atlassian_jira.curated_issue_assignee.api_client import ApiClient, RequestSerialized
from u_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_atlassian_jira.curated_issue_assignee.api_response import ApiResponse
from u_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_atlassian_jira.curated_issue_assignee.rest import RESTResponseType


class CuratedIssueAssigneeApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def replace_curated_issue_assignee_by_issue_id_or_key(
        self,
        issue_id_or_key: Annotated[StrictStr, Field(description="The issue key (ABCD-1234) or issue ID")],
        replace_curated_issue_assignee_by_issue_id_or_key_request: Annotated[ReplaceCuratedIssueAssigneeByIssueIdOrKeyRequest, Field(description="The object body")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> None:
        """Update a(n) curatedIssueAssignee

          Assigns or unassigns user to a Jira issue

        :param issue_id_or_key: The issue key (ABCD-1234) or issue ID (required)
        :type issue_id_or_key: str
        :param replace_curated_issue_assignee_by_issue_id_or_key_request: The object body (required)
        :type replace_curated_issue_assignee_by_issue_id_or_key_request: ReplaceCuratedIssueAssigneeByIssueIdOrKeyRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._replace_curated_issue_assignee_by_issue_id_or_key_serialize(
            issue_id_or_key=issue_id_or_key,
            replace_curated_issue_assignee_by_issue_id_or_key_request=replace_curated_issue_assignee_by_issue_id_or_key_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': None,
            '400': "DefaultError",
            '401': "DefaultError",
            '403': "DefaultError",
            '404': "DefaultError",
            '405': "DefaultError",
            '406': "DefaultError",
            '409': "DefaultError",
            '415': "DefaultError",
            '500': "DefaultError",
            '402': "DefaultError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def replace_curated_issue_assignee_by_issue_id_or_key_with_http_info(
        self,
        issue_id_or_key: Annotated[StrictStr, Field(description="The issue key (ABCD-1234) or issue ID")],
        replace_curated_issue_assignee_by_issue_id_or_key_request: Annotated[ReplaceCuratedIssueAssigneeByIssueIdOrKeyRequest, Field(description="The object body")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[None]:
        """Update a(n) curatedIssueAssignee

          Assigns or unassigns user to a Jira issue

        :param issue_id_or_key: The issue key (ABCD-1234) or issue ID (required)
        :type issue_id_or_key: str
        :param replace_curated_issue_assignee_by_issue_id_or_key_request: The object body (required)
        :type replace_curated_issue_assignee_by_issue_id_or_key_request: ReplaceCuratedIssueAssigneeByIssueIdOrKeyRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._replace_curated_issue_assignee_by_issue_id_or_key_serialize(
            issue_id_or_key=issue_id_or_key,
            replace_curated_issue_assignee_by_issue_id_or_key_request=replace_curated_issue_assignee_by_issue_id_or_key_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': None,
            '400': "DefaultError",
            '401': "DefaultError",
            '403': "DefaultError",
            '404': "DefaultError",
            '405': "DefaultError",
            '406': "DefaultError",
            '409': "DefaultError",
            '415': "DefaultError",
            '500': "DefaultError",
            '402': "DefaultError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def replace_curated_issue_assignee_by_issue_id_or_key_without_preload_content(
        self,
        issue_id_or_key: Annotated[StrictStr, Field(description="The issue key (ABCD-1234) or issue ID")],
        replace_curated_issue_assignee_by_issue_id_or_key_request: Annotated[ReplaceCuratedIssueAssigneeByIssueIdOrKeyRequest, Field(description="The object body")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Update a(n) curatedIssueAssignee

          Assigns or unassigns user to a Jira issue

        :param issue_id_or_key: The issue key (ABCD-1234) or issue ID (required)
        :type issue_id_or_key: str
        :param replace_curated_issue_assignee_by_issue_id_or_key_request: The object body (required)
        :type replace_curated_issue_assignee_by_issue_id_or_key_request: ReplaceCuratedIssueAssigneeByIssueIdOrKeyRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._replace_curated_issue_assignee_by_issue_id_or_key_serialize(
            issue_id_or_key=issue_id_or_key,
            replace_curated_issue_assignee_by_issue_id_or_key_request=replace_curated_issue_assignee_by_issue_id_or_key_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': None,
            '400': "DefaultError",
            '401': "DefaultError",
            '403': "DefaultError",
            '404': "DefaultError",
            '405': "DefaultError",
            '406': "DefaultError",
            '409': "DefaultError",
            '415': "DefaultError",
            '500': "DefaultError",
            '402': "DefaultError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _replace_curated_issue_assignee_by_issue_id_or_key_serialize(
        self,
        issue_id_or_key,
        replace_curated_issue_assignee_by_issue_id_or_key_request,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if issue_id_or_key is not None:
            _path_params['issueIdOrKey'] = issue_id_or_key
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if replace_curated_issue_assignee_by_issue_id_or_key_request is not None:
            _body_params = replace_curated_issue_assignee_by_issue_id_or_key_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'bearerAuth'
        ]

        return self.api_client.param_serialize(
            method='PUT',
            resource_path='/curated-issue-assignee/{issueIdOrKey}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


